/************************************************************************************/
/*  Program name CAPFAEXT_CAT_BOOK.sql                                              */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_DEPRN_PERIOD';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_DEPRN_PERIOD.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		*
	FROM
		FA_DEPRN_PERIODS
	WHERE	SUBSTR(Book_Type_Code,1,4)	=	p_NGO
	ORDER BY
		Book_Type_Code,
		Period_Counter;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Book_Type_Code||CHR(9)||
				C1.Period_Name||CHR(9)||
				C1.Period_Counter||CHR(9)||
				C1.Fiscal_Year||CHR(9)||
				C1.Period_Num||CHR(9)||
				C1.Period_Open_Date||CHR(9)||
				C1.Period_Close_Date||CHR(9)||
				C1.Depreciation_Batch_ID||CHR(9)||
				C1.Retirement_Batch_ID||CHR(9)||
				C1.Reclass_Batch_ID||CHR(9)||
				C1.Transfer_Batch_ID||CHR(9)||
				C1.Addition_Batch_ID||CHR(9)||
				C1.Adjustment_Batch_ID||CHR(9)||
				C1.Deferred_Deprn_Batch_ID||CHR(9)||
				C1.Calendar_Period_Open_Date||CHR(9)||
				C1.Calendar_Period_Close_Date||CHR(9)||
				C1.CIP_Addition_Batch_ID||CHR(9)||
				C1.CIP_Adjustment_Batch_ID||CHR(9)||
				C1.CIP_Reclass_Batch_ID||CHR(9)||
				C1.CIP_Retirement_Batch_ID||CHR(9)||
				C1.CIP_Reval_Batch_ID||CHR(9)||
				C1.CIP_Transfer_Batch_ID||CHR(9)||
				C1.Reval_Batch_ID||CHR(9)||
				C1.Deprn_Adjustment_Batch_ID||CHR(9)||
				C1.Deprn_Run
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No Deprn Period for NGO';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/